<?php

/**
 * HTMLmail plugin
 *
 *
 * Created: 2007-02-25
 * Last update: 2007-03-04
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

/**
 * Class used for template
 *
 */
class HTMLmail_template
{
    var $title;
    var $project;
    var $notification;
    var $id;
    var $bug;
    var $relationships;

    function HTMLmail_template() {
    }

    function SetBug( $p_id, $p_notification, $p_user_email_id = null ) {
        $this->title = bug_format_summary( $p_id, SUMMARY_CAPTION );
        $this->project = string_display( project_get_name( bug_get_field( $p_id, 'project_id' ) ) );
        $this->notification = $p_notification;
        $this->id = lang_get( 'id' );
        $this->bug = new HTMLmail_bug();
        $this->bug->SetBug( $p_id, bug_get_field( $p_id, 'project_id' ), $p_user_email_id );
        if ( config_get( 'enable_relationship' ) ) {
            $this->relationships = true;
        } else {
            $this->relationships = false;
        }
    }
};

class HTMLmail_bug
{
    var $id;
    var $category;
    var $severity;
    var $reproducibility;
    var $date_submitted;
    var $last_update;
    var $reporter;
    var $platform;
    var $assign_to;
    var $os;
    var $priority;
    var $os_version;
    var $status;
    var $product_version;
    var $product_build;
    var $resolution;
    var $projection;
    var $eta;
    var $fixed_in_version;
    var $target_version;
    var $summary;
    var $description;
    var $step_to_reproduce;
    var $additional_information;
    var $relationships;
    var $attached_files;
    
    function HTMLmail_bug() {
    }

    function SetBug( $p_id, $p_project_id = null, $p_user_email_id = null ) {
        $this->id = '<a href="' . config_get( 'path' ) . 'view.php?id=' . $p_id . '">' . bug_format_id( $p_id ) . '</a>';
        $t_bug_table = config_get( 'mantis_bug_table' );
        $c_bug_id = db_prepare_int( $p_id );
        $query = "SELECT *
			FROM $t_bug_table
			WHERE id='$c_bug_id'";
        $result = db_query( $query );
        $row = db_fetch_array( $result );
        extract( $row, EXTR_PREFIX_ALL, 'v' );
        $t_bug_text_table = config_get( 'mantis_bug_text_table' );
        $query = "SELECT *
			FROM $t_bug_text_table
			WHERE id='$v_bug_text_id'";
        $result = db_query( $query );
        $row = db_fetch_array( $result );
        extract( $row, EXTR_PREFIX_ALL, 'v2' );

        $v_os = string_display( $v_os );
        $v_os_build = string_display( $v_os_build );
        $v_platform = string_display( $v_platform );
        $v_version = string_display( $v_version );
        $v_summary = string_display_links( $v_summary );
        $v2_description = string_display_links( $v2_description );
        $v2_steps_to_reproduce = string_display_links( $v2_steps_to_reproduce );
        $v2_additional_information = string_display_links( $v2_additional_information );
        $this->category = $v_category;
        $this->severity = get_enum_element( 'severity', $v_severity );
        $this->reproducibility = get_enum_element( 'reproducibility', $v_reproducibility );
        $this->date_submitted = date( config_get( 'normal_date_format' ), db_unixtimestamp( $v_date_submitted ) );
        $this->last_update = date( config_get( 'normal_date_format' ), db_unixtimestamp( $v_last_updated ) );
        $this->reporter['id'] = $v_reporter_id;
        if ( $v_reporter_id != 0 ) {
            $this->reporter['name'] = user_get_name( $v_reporter_id );
            $this->reporter['email'] = user_get_email( $v_reporter_id );
            $this->reporter['show_email'] = access_has_project_level( config_get( 'show_user_email_threshold' ), $p_project_id, $p_user_email_id );
        } else {
            $this->reporter['name'] = '';
            $this->reporter['email'] = '';
            $this->reporter['show_email'] = false;
        }
        $this->platform = $v_platform;
        $this->assign_to['id'] = $v_handler_id;
        if ( $v_handler_id != 0 ) {
            $this->assign_to['name'] = user_get_name( $v_handler_id );
            $this->assign_to['email'] = user_get_email( $v_handler_id );
            $this->assign_to['show_email'] = access_has_project_level( config_get( 'show_user_email_threshold' ), $p_project_id, $p_user_email_id );
            $this->assign_to['show'] = access_has_bug_level( config_get( 'view_handler_threshold' ), $p_id, $p_user_email_id );
        } else {
            $this->assign_to['name'] = '';
            $this->assign_to['email'] = '';
            $this->assign_to['show_email'] = false;
            $this->assign_to['show'] = false;
        }
        $this->os = $v_os;
        $this->priority = get_enum_element( 'priority', $v_priority );
        $this->os_version = $v_os_build;
        $this->status = get_enum_element( 'status', $v_status );
        $this->product_version = $v_version;
        $this->product_build = $v_build;
        $this->resolution = get_enum_element( 'resolution', $v_resolution );
        $this->projection = get_enum_element( 'projection', $v_projection );
        $this->eta = get_enum_element( 'eta', $v_eta );
        $this->fixed_in_version = $v_fixed_in_version;
        $this->target_version = $v_target_version;
        if ( $v_duplicate_id != 0 && !config_get( 'enable_relationship' ) ) {
            $this->duplicate_id = string_get_bug_view_link( $v_duplicate_id );
        } else {
            $this->duplicate_id = '&nbsp;';
        }
        $t_related_custom_field_ids = custom_field_get_linked_ids( $v_project_id );
        $t_custom_fields = array();
        foreach( $t_related_custom_field_ids as $t_id ) {
            $t_def = custom_field_get_definition( $t_id );
            $t_custom_fields_elt = array();
            $t_custom_fields_elt['name'] = lang_get_defaulted( $t_def['name'] );
            $t_custom_fields_elt['value'] = string_custom_field_value( $t_def, $t_id, $p_id );
            $t_custom_fields[] = $t_custom_fields_elt;
        }
        $this->custom_fields = $t_custom_fields;
        $this->summary = bug_format_summary( $p_id, SUMMARY_FIELD );
        $this->description = $v2_description;
        $this->steps_to_reproduce = $v2_steps_to_reproduce;
        $this->additional_information = $v2_additional_information;
        // $this->relationships = relationship_get_summary_html_preview( $p_id );
        $t_project = false;
        $t_relationships = relationship_get_all( $p_id, $t_project );
        foreach( $t_relationships as $t_relation ) {
            $t_elt = array();
            if ( $p_id == $t_relation->src_bug_id ) {
                $t_elt['bug_id'] = $t_relation->dest_bug_id;
                $t_elt['project_id'] = $t_relation->dest_project_id;
                $t_elt['project_name'] = project_get_name( $t_relation->dest_project_id );
                $t_elt['relation'] = relationship_get_description_src_side( $t_relation->type );
            } else {
                $t_elt['bug_id'] = $t_relation->src_bug_id;
                $t_elt['project_id'] = $t_relation->src_project_id;
                $t_elt['project_name'] = project_get_name( $t_relation->src_project_id );
                $t_elt['relation'] = relationship_get_description_dest_side( $t_relation->type );
            }
            $t_elt['bug_url'] = config_get( 'path' ) . 'view.php?id=' . $t_elt['bug_id'];
            $t_bug = bug_prepare_display( bug_get( $t_elt['bug_id'], true ) );
            $t_elt['status'] = string_attribute( get_enum_element( 'status', $t_bug->status ) );
            if ( $t_bug->handler_id > 0 ) {
                $t_elt['handler']['id'] = $t_bug->handler_id;
                $t_elt['handler']['name'] = user_get_name( $t_bug->handler_id );
                $t_elt['handler']['email'] = user_get_email( $t_bug->handler_id );
                $t_elt['handler']['show_email'] = access_has_project_level( config_get( 'show_user_email_threshold' ), $t_bug->project_id, $p_user_email_id );
                
            } else {
                $t_elt['handler']['id'] = $t_bug->handler_id;
                $t_elt['handler']['name'] = '';
                $t_elt['handler']['email'] = '';
                $t_elt['handler']['show_email'] = access_has_project_level( config_get( 'show_user_email_threshold' ), $t_bug->project_id, $p_user_email_id );
            }
            $t_elt['summary'] = $t_bug->summary;
            $this->relationships[] = $t_elt;
        }
        $t_attachment_rows = bug_get_attachments( $p_id );
        $this->attached_files = array();
        foreach( $t_attachment_rows as $t_file ) {
            $t_elt = array();
            $t_elt['url'] = config_get( 'path' ) . 'file_download.php?file_id=' . $t_file['id'] . '&amp;type=bug';
            $t_elt['name'] = file_get_display_name( $t_file['filename'] );
            $t_elt['size'] = number_format( $t_file['filesize'] );
            $t_elt['date'] = date( config_get( 'normal_date_format' ), db_unixtimestamp( $t_file['date_added'] ) );
            $this->attached_files[] = $t_elt;
        }

        if ( !access_has_bug_level( config_get( 'private_bugnote_threshold' ), $p_id, $p_user_email_id ) ) {
            $t_restriction = 'AND view_state=' . VS_PUBLIC;
        } else {
            $t_restriction = '';
        }

        $t_bugnote_table = config_get( 'mantis_bugnote_table' );
        $t_bugnote_order = user_pref_get_pref( $p_user_email_id, 'bugnote_order' );

        $query = "SELECT *
			FROM $t_bugnote_table
			WHERE bug_id='$c_bug_id' $t_restriction
			ORDER BY date_submitted $t_bugnote_order";
        $result = db_query( $query );
        $this->bugnote_count = db_num_rows( $result );
        if ( $this->bugnote_count == 0 ) {
            $this->bugnote_msg = lang_get( 'no_bugnotes_msg' );
        } else {
            $this->bugnote_msg = lang_get( 'bug_notes_title' );
        }
        for ( $i=0; $i < $this->bugnote_count; $i++ ) {
            $row = db_fetch_array( $result );
            $this->bugnote[$i] = new HTMLmail_bugnote();
            $this->bugnote[$i]->SetBugnote( $row );
        }

        $this->history = array();
        $t_access_level_needed = config_get( 'view_history_threshold' );
	if ( access_has_bug_level( $t_access_level_needed, $p_id, $p_user_email_id ) ) {
            $t_history = history_get_events_array( $p_id );
            foreach ( $t_history as $t_item ) {
		$t_item['date_modified'] = $t_item['date'];
		$t_item['username'] = user_get_name( $t_item['userid'] );
		$t_item['field'] = string_display( $t_item['note'] );
		$t_item['change'] = string_display( $t_item['change'] );
                $this->history[] = $t_item;
            }
	}
    }
};

class HTMLmail_bugnote
{
    function HTMLmail_bugnote() {

    }

    function SetBugnote( $p_row ) {
        extract( $p_row, EXTR_PREFIX_ALL, 'v3' );
        $v3_date_submitted = date( config_get( 'normal_date_format' ), ( db_unixtimestamp( $v3_date_submitted ) ) );
        $v3_last_modified = date( config_get( 'normal_date_format' ), ( db_unixtimestamp( $v3_last_modified ) ) );
        $t_bugnote_text_table = config_get( 'mantis_bugnote_text_table' );
        $query = "SELECT note, id
				FROM $t_bugnote_text_table
				WHERE id='$v3_bugnote_text_id'";
        $result2 = db_query( $query );
        $v3_note = db_result( $result2, 0, 0 );
        $v3_bugnote_text_id = db_result( $result2, 0, 1 );
        
        $v3_note = string_display_links( $v3_note );
        $this->id = bugnote_format_id( $v3_id );
        $this->reporter = user_get_name( $v3_reporter_id );
        $this->date_submitted = $v3_date_submitted;
        if ( db_unixtimestamp( $v3_date_submitted ) != db_unixtimestamp( $v3_last_modified ) ) {
            $this->last_modified = '<br />(' . lang_get( 'edited_on').' '. $v3_last_modified . ')';
        } else {
            $this->last_modified = '';
        }
        $this->note = $v3_note;
    }
};

?>
