<?php

/**
 * HTMLmail plugin
 *
 *
 * Created: 2007-02-17
 * Last update: 2007-03-04
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

if ( !ereg( 'plugins_page.php', $_SERVER['REQUEST_URI'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_user_id = auth_get_current_user_id();

$t_action = gpc_get_string( 'action', 'none' );
if ( $t_action == 'update' ) {
    $t_project_id = gpc_get_int( 'project_id' );
    $t_format = gpc_get_int( 'format' );
    $t_template = gpc_get_string( 'template' );
    config_set( 'plugins_htmlmail_format', $t_format, $t_user_id, $t_project_id );
    config_set( 'plugins_htmlmail_template', $t_template, $t_user_id, $t_project_id );
    if ( user_is_administrator( $t_user_id ) ) {
        $t_format = gpc_get_int( 'default_format' );
        $t_template = gpc_get_string( 'default_template' );
        config_set( 'plugins_htmlmail_format', $t_format, NO_USER, $t_project_id );
        config_set( 'plugins_htmlmail_template', $t_template, NO_USER, $t_project_id );
    }
    header( 'Location: plugins_page.php?plugin=htmlmail' );
    exit();
}

$t_project_id = helper_get_current_project();

html_page_top1( lang_get( 'plugins_htmlmail_page_title' ) );
html_page_top2();

echo "\n\n";
echo "<br />\n<div align=\"center\">\n";
echo '  ' . str_replace( '%%project%%', '<b>' . project_get_name( $t_project_id ) . '</b>', lang_get( 'plugins_htmlmail_configuration_for_project' ) ) . "\n";

?>
  <br /><br />
  <form name="plugins_htmlmail" method="post" action="plugins_page.php">
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
    <input type="hidden" name="plugin" value="htmlmail" />
    <table class="width75" cellspacing="1">

<?php

if ( user_is_administrator( $t_user_id ) ) {

?>

      <!-- Default Format -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_htmlmail_default_format' ) ?>
        </td>
        <td width="70%">
          <select name="default_format">
            <option value="<?php echo PLUGINS_HTMLMAIL_FORMAT_TEXT . '"'; check_selected( config_get( 'plugins_htmlmail_format', PLUGINS_HTMLMAIL_FORMAT_DEFAULT, NO_USER ), PLUGINS_HTMLMAIL_FORMAT_TEXT ) ?>>Text</option>
            <option value="<?php echo PLUGINS_HTMLMAIL_FORMAT_HTML . '"'; check_selected( config_get( 'plugins_htmlmail_format', PLUGINS_HTMLMAIL_FORMAT_DEFAULT, NO_USER ), PLUGINS_HTMLMAIL_FORMAT_HTML ) ?>>HTML (<?php echo lang_get( 'plugins_htmlmail_not_recommended' ) ?>)</option>
            <option value="<?php echo PLUGINS_HTMLMAIL_FORMAT_TEXT_HTML . '"'; check_selected( config_get( 'plugins_htmlmail_format', PLUGINS_HTMLMAIL_FORMAT_DEFAULT, NO_USER ), PLUGINS_HTMLMAIL_FORMAT_TEXT_HTML ) ?>>Text/HTML</option>
          </select>
        </td>
      </tr>

      <!-- Default Template -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_htmlmail_default_template' ) ?>
        </td>
        <td width="70%">
          <select name="default_template">
<?php plugins_htmlmail_print_template_option_list( config_get( 'plugins_htmlmail_template', PLUGINS_HTMLMAIL_TEMPLATE_DEFAULT, NO_USER ) ) ?>
          </select>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

<?php

}

?>
      <!-- Format -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_htmlmail_format' ) ?>
        </td>
        <td width="70%">
          <select name="format">
            <option value="<?php echo PLUGINS_HTMLMAIL_FORMAT_TEXT . '"'; check_selected( config_get( 'plugins_htmlmail_format', PLUGINS_HTMLMAIL_FORMAT_DEFAULT ), PLUGINS_HTMLMAIL_FORMAT_TEXT ) ?>>Text</option>
            <option value="<?php echo PLUGINS_HTMLMAIL_FORMAT_HTML . '"'; check_selected( config_get( 'plugins_htmlmail_format', PLUGINS_HTMLMAIL_FORMAT_DEFAULT ), PLUGINS_HTMLMAIL_FORMAT_HTML ) ?>>HTML (<?php echo lang_get( 'plugins_htmlmail_not_recommended' ) ?>)</option>
            <option value="<?php echo PLUGINS_HTMLMAIL_FORMAT_TEXT_HTML . '"'; check_selected( config_get( 'plugins_htmlmail_format', PLUGINS_HTMLMAIL_FORMAT_DEFAULT ), PLUGINS_HTMLMAIL_FORMAT_TEXT_HTML ) ?>>Text/HTML</option>
          </select>
        </td>
      </tr>

      <!-- Template -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_htmlmail_template' ) ?>
        </td>
        <td width="70%">
          <select name="template">
<?php plugins_htmlmail_print_template_option_list( config_get( 'plugins_htmlmail_template', PLUGINS_HTMLMAIL_TEMPLATE_DEFAULT ) ) ?>
          </select>
        </td>
      </tr>

      <!-- Submit Button -->
      <tr>
        <td class="left">
          <span class="required"> * <?php echo lang_get( 'required' ) ?></span>
        </td>
        <td class="center">
          <input tabindex="19" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" />
        </td>
      </tr>
    </table>
  </form>

<?php

echo "</div>\n";

html_page_bottom1( __FILE__ );

?>
